<?

function Stretch(&$sString1, &$sString2, $sChar)
{
	$iChars = Max(StrLen($sString1), StrLen($sString2));
	
	$sString1 = Str_Pad($sString1, $iChars, $sChar, STR_PAD_LEFT);
	$sString2 = Str_Pad($sString2, $iChars, $sChar, STR_PAD_LEFT);
}

//Octet String To Integer
function OS2I($sString)
{
	$qNumber = '0';

	$iStrLen = StrLen($sString);
	for($i = 0; $i < $iStrLen; $i++)
	{
		$iChar = Ord($sString[$iStrLen - $i - 1]);
		$qNumber = bcadd($qNumber, bcmul($iChar, bcpow('256', $i)));
	}

	return $qNumber;
}

//Integer To Octet String
function I2OS($qNumber, $iLength = -1)
{
	$sString = '';

	if($iLength < 0)
	{
		while($qNumber != '0')
		{
			$sString = Chr(bcmod($qNumber, '256')) . $sString;
			$qNumber = bcdiv($qNumber, '256');
		}
	}
	else
	{
		for($i = 0; $i < $iLength; $i++)
		{
			$sString = Chr(bcmod($qNumber, '256')) . $sString;
			$qNumber = bcdiv($qNumber, '256');
		}
	}

	return $sString;
}

for($i = 0; $i < 10; $i++)
	$g_aConversion[StrVal($i)] = StrVal($i); //0-9

for($i = 0; $i < 26; $i++)
	$g_aConversion[StrVal($i + 10)] = Chr($i + 97); //a-z

for($i = 0; $i < 128; $i++)
	$g_aConversion[StrVal($i + 36)] = Chr($i + 128); //#128 - #255


function bcdec2x($qNumber, $qBase)
{
	global $g_aConversion;
	
	$sString = '';

	while($qNumber != '0')
	{
		$sString = $g_aConversion[bcmod($qNumber, $qBase)] . $sString;
		$qNumber = bcdiv($qNumber, $qBase);
	}

	return $sString;
}

function bcx2dec($sString, $qBase)
{
	global $g_aConversion;

	$qNumber = '0';

	$iStrLen = StrLen($sString);
	for($i = 0; $i < $iStrLen; $i++)
	{
		$iPos = array_search($sString[$iStrLen - $i - 1], $g_aConversion);
		$qNumber = bcadd($qNumber, bcmul($iPos, bcpow($qBase, $i)));
	}

	return $qNumber;
}

function bcbin($qOperand)
{
	$qResult = '';
	while($qOperand != '0')
	{
		$qResult = bcmod($qOperand, '2') . $qResult;
		$qOperand = bcdiv($qOperand, '2');
	}
	return $qResult;
}

/*
7 ^ 23 = 27368747340080916343
27368747340080916343 mod 311 = 234
*/
function bcpowmod($b, $e, $m)
{
	$b = bcmod($b, $m);

	$bin_e = StrRev(bcbin($e));
	$qResult = '1';

	$ae[0] = $b;
	for($i = 1; $i < StrLen($bin_e); $i++)
		$ae[$i] = bcmod(bcpow($ae[$i - 1], 2), $m);

	for($i = 0; $i < StrLen($bin_e); $i++)
		if($bin_e[$i] == '1')
		  $qResult = bcmod(bcmul($qResult, $ae[$i]), $m);

	return $qResult;
}

/*
Euklids Alogirthmus um folgende Gleichung a * x mod n = 1
nach x aufzuloesen, mit der Bedingung, dass 0 < a < n
*/
function bcinv($a, $n)
{
	$x = '';

	$g[0] = $n;
	$g[1] = $a;
	$v[0] = '0';
	$v[1] = '1';

	$i = 1;
	while($g[$i] != '0')
	{
		$g[$i + 1] = bcmod($g[$i - 1], $g[$i]);
		$y = bcdiv($g[$i - 1], $g[$i]);
		$t = bcmul($y, $v[$i]);
		$v[$i + 1] = $v[$i - 1];
		$v[$i + 1] = bcsub($v[$i + 1], $t);
		$i++;
	}

	$x = $v[$i - 1];
	if(bccomp($x, '0') < 0)
		$x = bcadd($x, $n);

	return $x;
}

/*
Schon wieder der nette Euklid der uns folgenden Alogorithmus
zur Berechnung des GGT mit auf den Weg gegeben hat
*/
function bcgcd($qOperand1, $qOperand2)
{
	do
	{
		$qModulo = bcmod($qOperand1, $qOperand2);
		$qOperand1 = $qOperand2;
		$qOperand2 = $qModulo;
	}
	while($qModulo != '0');
	return $qOperand1;
}

//32 << 2 = 128
function bcshl($qOperand, $qBits)
{
	return bcmul($qOperand, bcpow(2, $qBits));
}

//32 >> 2 = 8
function bcshr($qOperand, $qBits)
{
	return bcdiv($qOperand, bcpow(2, $qBits));
}

//980299 And 289273 = 287049
function bcand2($qOperand1, $qOperand2)
{
	$qOperand1 = I2OS($qOperand1);
	$qOperand2 = I2OS($qOperand2);
	Stretch($qOperand1, $qOperand2, Chr(0));

	$qResult = '';
	for($i = 0; $i < StrLen($qOperand1); $i++)
	{
		$iValue1 = Ord($qOperand1[$i]);
		$iValue2 = Ord($qOperand2[$i]);
		$qResult .= Chr($iValue1 & $iValue2);
	}
	return OS2I($qResult);
}

function bcand()
{
	$qResult = Func_Get_Arg(0);
	for($i = 1; $i < Func_Num_Args(); $i++)
	{
		$qOperand = Func_Get_Arg($i);
		$qResult = bcand2($qResult, $qOperand);
	}
	return $qResult;
}


//980299 Or 289273 = 982523
function bcor2($qOperand1, $qOperand2)
{
	$qOperand1 = I2OS($qOperand1);
	$qOperand2 = I2OS($qOperand2);
	Stretch($qOperand1, $qOperand2, Chr(0));

	$qResult = '';
	for($i = 0; $i < StrLen($qOperand1); $i++)
	{
		$iValue1 = Ord($qOperand1[$i]);
		$iValue2 = Ord($qOperand2[$i]);
		$qResult .= Chr($iValue1 | $iValue2);
	}
	return OS2I($qResult);
}

function bcor()
{
	$qResult = Func_Get_Arg(0);
	for($i = 1; $i < Func_Num_Args(); $i++)
	{
		$qOperand = Func_Get_Arg($i);
		$qResult = bcor2($qResult, $qOperand);
	}
	return $qResult;
}

//980299 Xor 289273 = 695474
function bcxor2($qOperand1, $qOperand2)
{
	$qOperand1 = I2OS($qOperand1);
	$qOperand2 = I2OS($qOperand2);
	Stretch($qOperand1, $qOperand2, Chr(0));

	$qResult = '';
	for($i = 0; $i < StrLen($qOperand1); $i++)
	{
		$iValue1 = Ord($qOperand1[$i]);
		$iValue2 = Ord($qOperand2[$i]);
		$qResult .= Chr($iValue1 ^ $iValue2);
	}
	return OS2I($qResult);
}

function bcxor()
{
	$qResult = Func_Get_Arg(0);
	for($i = 1; $i < Func_Num_Args(); $i++)
	{
		$qOperand = Func_Get_Arg($i);
		$qResult = bcxor2($qResult, $qOperand);
	}
	return $qResult;
}

function bcnot($qOperand, $iBits)
{
	$qOperand = bcdec2x($qOperand, 2);
	$qOperand = Str_Pad($qOperand, $iBits, '0', STR_PAD_LEFT);

	$qResult = '';
	for($i = 0; $i < $iBits; $i++)
		$qResult .= ($qOperand[$i] == '1') ? '0' : '1';
	return bcx2dec($qResult, 2);
}


?>